@echo off
echo "Opening end user license agreement"
pause
start write "%~dp0\eula.txt"
SET /P agreed="By pressing 'y', you agree with our end user license agreement: "
set _configpostfix=

IF not "%agreed%"=="y" goto :finish

set _my_datetime=%date%_%time%
set _my_datetime=%date%_%time%
set _my_datetime=%_my_datetime: =_%
set _my_datetime=%_my_datetime::=%
set _my_datetime=%_my_datetime:/=_%
set _my_datetime=%_my_datetime:.=_%

echo %_my_datetime%
echo Checking admin mode
net session >nul 2>&1
if %errorLevel% == 0 (
   echo Success: Administrative permissions confirmed.
) else (
   goto error_noaccess
)


if "%ProgramFiles(x86)%" NEQ "" goto :do64
:do32
echo x86 detected
if not exist "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.dll" goto install32
echo backup files
ren "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.dll" "iispeedmodule.%_my_datetime%.dll"
ren "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.pdb" "iispeedmodule.%_my_datetime%.pdb"

copy "%ProgramFiles%\we-amp\iispeed\release\iispeed.config" "iispeed.%_my_datetime%.config"
set _configpostfix=.new.1.1.7
if not exist "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.%_my_datetime%.dll" goto error_noaccess
:install32
if not exist "%ProgramFiles%\we-amp\iispeed\release\" mkdir "%ProgramFiles%\we-amp\iispeed\release\"
echo copying IISpeed to destination
copy /y "%~dp0\x86\iispeedmodule.dll" "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.dll"
copy /y "%~dp0\x86\iispeedmodule.pdb" "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.pdb"
copy /y "%~dp0\iispeed.config" "%ProgramFiles%\we-amp\iispeed\release\iispeed.config%_configpostfix%"
if not exist "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.dll" goto error_noaccess
echo Removing old HttpModule registration, any errors can be ignored:
%SYSTEMROOT%\system32\inetsrv\appcmd.exe uninstall module "We-Amp IISpeed"
%SYSTEMROOT%\system32\inetsrv\appcmd.exe install module /name:"We-Amp IISpeed" /image:"%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.dll" /add:true
echo restart iis
iisreset /restart /timeout:1
echo IISpeed install OK!

goto end
:do64
echo x64 detected
if "%ProgramFiles%"=="%ProgramFiles(x86)%" goto error_32bitson64
if not exist "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.dll" goto install64
echo backup files
ren "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.dll" "iispeedmodule.%_my_datetime%.dll"
ren "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.pdb" "iispeedmodule.%_my_datetime%.pdb"
copy "%ProgramFiles%\we-amp\iispeed\release\iispeed.config" "iispeed.%_my_datetime%.config"
ren "%ProgramFiles(x86)%\we-amp\iispeed\release\iispeedmodule.dll" "iispeedmodule.%_my_datetime%.dll"
ren "%ProgramFiles(x86)%\we-amp\iispeed\release\iispeedmodule.pdb" "iispeedmodule.%_my_datetime%.pdb"
copy "%ProgramFiles(x86)%\we-amp\iispeed\release\iispeed.config" "iispeed.%_my_datetime%.config"
set _configpostfix=.new.1.1.7
if not exist "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.%_my_datetime%.dll" goto error_noaccess
:install64
if not exist "%ProgramFiles%\we-amp\iispeed\release\" mkdir "%ProgramFiles%\we-amp\iispeed\release\"
if not exist "%ProgramFiles(x86)%\we-amp\iispeed\release\" mkdir "%ProgramFiles(x86)%\we-amp\iispeed\release\"
echo copying IISpeed to destinations
copy /y "%~dp0\x64\iispeedmodule.dll" "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.dll"
copy /y "%~dp0\x64\iispeedmodule.pdb" "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.pdb"
copy /y "%~dp0\iispeed.config" "%ProgramFiles%\we-amp\iispeed\release\iispeed.config%_configpostfix%"
copy /y "%~dp0\x86\iispeedmodule.dll"  "%ProgramFiles(x86)%\we-amp\iispeed\release\iispeedmodule.dll" 
copy /y "%~dp0\x86\iispeedmodule.pdb"  "%ProgramFiles(x86)%\we-amp\iispeed\release\iispeedmodule.pdb" 
copy /y "%~dp0\iispeed.config"  "%ProgramFiles(x86)%\we-amp\iispeed\release\iispeed.config%_configpostfix%" 
if not exist "%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.dll" goto error_noaccess
echo Removing old HttpModule registration, any errors can be ignored:
%SYSTEMROOT%\system32\inetsrv\appcmd.exe uninstall module "We-Amp IISpeed"
echo Removing old 32 bits HttpModule registration, any errors can be ignored:
%SYSTEMROOT%\system32\inetsrv\appcmd.exe uninstall module "We-Amp IISpeed 32bits release"
%SYSTEMROOT%\system32\inetsrv\appcmd.exe install module /name:"We-Amp IISpeed" /image:"%ProgramFiles%\we-amp\iispeed\release\iispeedmodule.dll" /add:true /precondition:bitness64
%SYSTEMROOT%\system32\inetsrv\appcmd.exe install module /name:"We-Amp IISpeed 32bits release" /image:"%ProgramFiles(x86)%\we-amp\iispeed\release\iispeedmodule.dll" /add:true /precondition:bitness32
iisreset /restart /timeout:1
IF not "%_configpostfix%"=="" echo We left your iispeed.config file intact, the new version is in iispeed.config.%_configpostfix%
echo IISpeed install OK!
goto end
:error_noaccess
echo Install script finished with errors, please run this script with -run as administrator-
goto end
:error_32bitson64
echo Somehow running in a shell in 32 bits mode on a 64 bits platform, cannot install, please start from explorer (run as administrator), or an elevated cmd
goto end
:end
pause
:finish